{% extends "base.html.j2" %}
{% block meta %}
<link rel="stylesheet" type="text/css" href="/static/css/media.css" />
<link rel="stylesheet" type="text/css" href="/static/css/dashboard.css" />
{% endblock %}

{% block content %}
    <div id="sticky_anchor"></div>
    <div id="account_scroll" class="block">
        <div class="page_loading light_blue"></div>
        <div class="inner_content">
            <div class="content">
                <ul class="user_menu menu">

                    <li class="border_color light_blue selected"><a href="{{url_for('profile')}}">Sobre</a></li>
                    <li class="border_color light_blue"><a href="{{url_for('profile_edit')}}">Editar</a></li>
                    {# <li class="border_color light_blue selected"><a href="{{url_for('profile_delete')}}">Eliminar</a></li> #}

                </ul>
            </div>
        </div>
    </div>

    <div class="bg_image">
        <div class="block header gradient light_blue">
            <div class="inner_content">
                <div class="content">
                    <span class="avatar">
                        {# <a href="{{url_for('profile', username=user.username)}}"> #}
                            <img class="avatar" title="Gravatar" src="{{user.avatar(150)}}" width="150" height="150">
                        {# </a> #}
                    </span>

                    <div>
                        <div class="about">
                            <div class="content_wrapper">
                                <h2>{{user.username}}</h2>
                                {% if user.confirmed %}
                                <h3>Miembro desde {{user.member_since()}}</h3>
                                {% else  %}
                                <h3>Miembro <u>sin verificar</u></h3>
                                {% endif %}

                                {% if user.is_mod() %}
                                <span style="padding-left: 1em; padding-top: 1em;">
                                [
                                    {% if current_user.is_admin() %}
                                    <span style="display: inline; font-weight: bold; color: #ff4136;">administrador</span>
                                    {% else %}
                                    <span style="display: inline; font-weight: bold; color: #ffdc00;">moderador</span>
                                    {% endif %}
                                ]
                                </span>
                                {% endif %}
                            </div>

                            <div class="content_wrapper flex">
                                <div class="block">
                                    <div class="consensus">
                                        <a href="{{url_for('panel_content', media_type="pelis")}}">
                                        <div class="outer_ring">
                                            <div class="user_score_chart" data-percent="{{user.uploaded_movies_len()}}" data-track-color="#204529" data-bar-color="#21d07a">
                                                <div class="percent">
                                                    <span class="icon icon-r{{user.uploaded_movies_len()}}"></span>
                                                </div>
                                                <canvas height="60" width="60"></canvas></div>
                                        </div>
                                        </a>
                                    </div>
                                    <div class="text">Pelís</div>
                                </div>

                                <div class="block">
                                    <div class="consensus">
                                        <a href="{{url_for('panel_content', media_type="series")}}">
                                        <div class="outer_ring">
                                            <div class="user_score_chart" data-percent="{{user.uploaded_series_len()}}" data-track-color="#204529" data-bar-color="#21d07a">
                                                <div class="percent">
                                                    <span class="icon icon-r{{user.uploaded_series_len()}}"></span>
                                                </div>
                                                <canvas height="60" width="60"></canvas></div>
                                        </div>
                                        </a>
                                    </div>
                                    <div class="text">Series</div>
                                </div>

                                <div class="block">
                                    <div class="consensus">
                                        <a href="{{url_for('panel_content', media_type="animes")}}">
                                        <div class="outer_ring">
                                            <div class="user_score_chart" data-percent="{{user.uploaded_animes_len()}}" data-track-color="#204529" data-bar-color="#21d07a">
                                                <div class="percent">
                                                    <span class="icon icon-r{{user.uploaded_animes_len()}}"></span>
                                                </div>
                                                <canvas height="60" width="60"></canvas></div>
                                        </div>
                                        </a>
                                    </div>
                                    <div class="text">Animes</div>
                                </div>

                                <div class="block">
                                    <div class="consensus">
                                        <a href="{{url_for('panel_content', media_type="documentales")}}">
                                        <div class="outer_ring">
                                            <div class="user_score_chart" data-percent="{{user.uploaded_documentales_len()}}" data-track-color="#204529" data-bar-color="#21d07a">
                                                <div class="percent">
                                                    <span class="icon icon-r{{user.uploaded_documentales_len()}}"></span>
                                                </div>
                                                <canvas height="60" width="60"></canvas></div>
                                        </div>
                                        </a>
                                    </div>
                                    <div class="text">Documentales</div>
                                </div>

                                <div class="social_links">
                                </div>
                            </div>

                            <div class="content_wrapper">
                                <p>{{user.about_me}}</p>
                                <hr>
                                <p>{{user.phrase}}</p>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <div class="account_page_data">
        <div class="inner_block">
            <div class="inner_content">
                <div class="content">
                    <div class="title_header">
                        <div class="title_group">

                            <h2>Mis favoritos</h2>

                            <div>
                                {% if media_type == "peli" %}
                                <h3 class="scroll border_color light_blue on">
                                    <a href="{{url_for('profile_favorites', media_type="pelis")}}">Películas
                                        <span class="color light_blue">{{user.favorite_movies()|length}}</span>
                                    </a>
                                </h3>

                                <h3 class="scroll border_color light_blue">
                                    <a href="{{url_for('profile_favorites', media_type="series")}}">Series
                                        <span class="color light_blue">{{user.favorite_series()|length}}</span>
                                    </a>
                                </h3>

                                <h3 class="scroll border_color light_blue">
                                    <a href="{{url_for('profile_favorites', media_type="animes")}}">Animes
                                        <span class="color light_blue">{{user.favorite_animes()|length}}</span>
                                    </a>
                                </h3>

                                <h3 class="scroll border_color light_blue">
                                    <a href="{{url_for('profile_favorites', media_type="documentales")}}">Documentales
                                        <span class="color light_blue">{{user.favorite_documentales()|length}}</span>
                                    </a>
                                </h3>

                                {% elif media_type == "serie" %}
                                <h3 class="scroll border_color light_blue">
                                    <a href="{{url_for('profile_favorites', media_type="pelis")}}">Películas
                                        <span class="color light_blue">{{user.favorite_movies()|length}}</span>
                                    </a>
                                </h3>

                                <h3 class="scroll border_color light_blue on">
                                    <a href="{{url_for('profile_favorites', media_type="series")}}">Series
                                        <span class="color light_blue">{{user.favorite_series()|length}}</span>
                                    </a>
                                </h3>

                                <h3 class="scroll border_color light_blue">
                                    <a href="{{url_for('profile_favorites', media_type="animes")}}">Animes
                                        <span class="color light_blue">{{user.favorite_animes()|length}}</span>
                                    </a>
                                </h3>

                                <h3 class="scroll border_color light_blue">
                                    <a href="{{url_for('profile_favorites', media_type="documentales")}}">Documentales
                                        <span class="color light_blue">{{user.favorite_documentales()|length}}</span>
                                    </a>
                                </h3>

                                {% elif media_type == "anime" %}
                                <h3 class="scroll border_color light_blue">
                                    <a href="{{url_for('profile_favorites', media_type="pelis")}}">Películas
                                        <span class="color light_blue">{{user.favorite_movies()|length}}</span>
                                    </a>
                                </h3>

                                <h3 class="scroll border_color light_blue">
                                    <a href="{{url_for('profile_favorites', media_type="series")}}">Series
                                        <span class="color light_blue">{{user.favorite_series()|length}}</span>
                                    </a>
                                </h3>

                                <h3 class="scroll border_color light_blue on">
                                    <a href="{{url_for('profile_favorites', media_type="animes")}}">Animes
                                        <span class="color light_blue">{{user.favorite_animes()|length}}</span>
                                    </a>
                                </h3>

                                <h3 class="scroll border_color light_blue">
                                    <a href="{{url_for('profile_favorites', media_type="documentales")}}">Documentales
                                        <span class="color light_blue">{{user.favorite_documentales()|length}}</span>
                                    </a>
                                </h3>

                                {% else %}
                                <h3 class="scroll border_color light_blue">
                                    <a href="{{url_for('profile_favorites', media_type="pelis")}}">Películas
                                        <span class="color light_blue">{{user.favorite_movies()|length}}</span>
                                    </a>
                                </h3>

                                <h3 class="scroll border_color light_blue">
                                    <a href="{{url_for('profile_favorites', media_type="series")}}">Series
                                        <span class="color light_blue">{{user.favorite_series()|length}}</span>
                                    </a>
                                </h3>

                                <h3 class="scroll border_color light_blue">
                                    <a href="{{url_for('profile_favorites', media_type="animes")}}">Animes
                                        <span class="color light_blue">{{user.favorite_animes()|length}}</span>
                                    </a>
                                </h3>

                                <h3 class="scroll border_color light_blue on">
                                    <a href="{{url_for('profile_favorites', media_type="documentales")}}">Documentales
                                        <span class="color light_blue">{{user.favorite_documentales()|length}}</span>
                                    </a>
                                </h3>
                                {% endif %}
                            </div>
                        </div>
                    </div>

                    <div class="items_wrapper">
                        <br>
                        {% if media|length < 1 %}
                        <p>Aún no tienes favoritos</p>
                        {% else %}
                        <div class="results_page">

                            {% for item in media %}

                            <div class="card v4">
                                <div class="image">
                                    <div class="poster">
                                        <a href="/{{item.media_type}}/{{item.title_unique}}">
                                            <img class="poster fade lazyautosizes lazyloaded"
                                                 alt="{{item.title}}" sizes="150px" src="data:image/png;base64, {{item.lposter_b64}}">
                                        </a>
                                    </div>
                                </div>

                                <div class="details">
                                    <div class="flex_space_between">
                                        <div class="wrapper">
                                            <div class="consensus tight">
                                                <div class="outer_ring">
                                                    <div class="user_score_chart {{item.hash()}}" data-percent="{{item.score}}" data-track-color="#204529" data-bar-color="#21d07a">
                                                        <div class="percent">

                                                            <span class="icon icon-r{{item.score|round|int}}"></span>

                                                        </div>
                                                        <canvas height="32" width="32"></canvas><canvas height="32" width="32"></canvas><canvas height="32" width="32"></canvas></div>
                                                </div>
                                            </div>

                                            <div class="title">
                                                <a href="/{{item.media_type}}/{{item.title_unique}}"><h2>{{item.title}}</h2></a>
                                                <span class="release_date">{{item.release_date.strftime('%b %d, %Y')}}</span>
                                            </div>
                                        </div>

                                        <div class="overview true" style="word-wrap: break-word;"><p>{{item.description|truncate(330)}}</p></div>
                                    </div>

                                    <div class="action_bar">
                                        <ul>
                                            <li><a class="list_item_rating" href="/{{item.media_type}}/{{item.title_unique}}"><span class="glyphicons glyphicons-play"></span> Ver</a></li>

                                            <li><a class="remove_list_item" href="{{url_for('favorite_delete', title_unique=item.title_unique)}}"><span class="glyphicons glyphicons-remove"></span> Eliminar</a></li>

                                        </ul>
                                    </div>

                                </div>

                                <script>
                                    $(function() {
                                        $('.user_score_chart.{{item.hash()}}').easyPieChart({
                                            lineCap: 'round',
                                            lineWidth: 3,
                                            scaleColor: false,
                                            size: 32,
                                            animate: {
                                                enabled: false
                                            }
                                        });
                                    });
                                </script>
                            </div>

                            {% endfor %}

                        </div>

                    {% endif %}

                    </div>
                </div>
            </div>
        </div>
    </div>

    <script>
        var media_type = '';
var requestParams = {};
var currentPage = 1;

function pushGAEvent(href) {
    ga('set', 'page', href);
    ga('send', 'pageview');
}

var pageLoader = $('div.page_loading');

function activatePageLoader(loader) {
    loader.addClass('on');
}

function deactivatePageLoader(loader) {
    loader.addClass('fade_out');
    loader.one('webkitTransitionEnd otransitionend oTransitionEnd msTransitionEnd transitionend', function(e) {
        loader.removeClass('fade_out').removeClass('on');
    });
}

$(document).ready(function(){
    $('div.card.v4 div.overview').dotdotdot();

    var wrap = $("#account_scroll");
    var wrap_top = wrap.offset().top;

    $(window).on("scroll", function(e) {
        if ($(window).scrollTop() > (wrap_top - 106)) {
            wrap.addClass("stick");
            $('#sticky_anchor').height(wrap.outerHeight());
        } else {
            wrap.removeClass("stick");
            $('#sticky_anchor').height(0);
        }
    });

    $('ul.user_menu.menu li a').on('click', function() {
        var contentDiv = $('div.account_page_data');
        var contentHeight = contentDiv.outerHeight();
        contentDiv.css({ height: contentHeight })
        contentDiv.html('');

        $('ul.user_menu.menu li').removeClass('selected');
        $(this).parent().addClass('selected');

        if (wrap.hasClass('stick')) {
            $('body').scrollTo((wrap_top - 105), 0);
        }

        var href = $(this).attr('href');
        History.pushState({}, $(this).attr('data-title'), href);

        media_type = 'movie';
        clearWithTextSearch();

        $.ajax({
            url: $(this).attr('data-partial'),
            beforeSend: function() {
                activatePageLoader(pageLoader);
            }
        }).fail(function() {
            showError('Oops!, Hay un problema.');
            deactivatePageLoader(pageLoader);
        }).done(function(response) {
            deactivatePageLoader(pageLoader);

            contentDiv.css({ height: 'auto' }).html(response);
            $('div.card.v4 div.overview').dotdotdot();
            $("time.timeago").timeago();


            pushGAEvent(href);

        });
    });

    $("div.account_page_data").on('click', 'a.sort_order', function(e) {
        $('a.sort_order').toggleClass('selected hide');
        $('li.selected a.filter_list').click();
    });

    $("div.account_page_data").on('click', 'div.title_header h3.scroll a', function(e) {
        media_type = $(this).attr('data-media-type');
        $('div.title_header h3').removeClass('on');
        $(this).parent().addClass('on');

        clearWithTextSearch();
    });

    $("div.account_page_data").on('click', ' a.filter_list', function(e) {
        var selected_sort = $(this).attr('data-sort-by');

        if ( selected_sort == 'default' || selected_sort == 'upcoming' ) {
            $('div.order_filter').addClass('hide');
        } else {
            $('div.order_filter').removeClass('hide');
        }

        if ( (selected_sort == 'upcoming' || selected_sort == 'account_rating' || selected_sort == 'created_at') && $('#with_text_search').val() ) {
            clearWithTextSearch();
        }

        setFilter(selected_sort);
    });

    $("div.account_page_data").on('click', 'div.title_header h3.scroll a, a.filter_list', function(e) {
        if (wrap.hasClass('stick')) {
            $('body').scrollTo((wrap_top - 105), 0);
        }

        var href = $(this).attr('href');
        var partial_href = $(this).attr('data-partial');

        History.pushState({}, $(this).attr('data-title'), href);
        $.extend(requestParams, { sort_by: $(this).attr('data-sort-by') });

        filterItems(partial_href);


        pushGAEvent(href);

    });

    $("div.account_page_data").on('click', 'a.item_search_button', function(e) {
        var selected_form = $('form.item_search_form');
        selected_form.toggleClass('hide');

        $('div.content div.title_header div.filter_group div.sort_filter').toggleClass('hide');

        selected_form.one('webkitAnimationEnd oanimationend msAnimationEnd animationend', function(e) {
            $('form.item_search_form input').focus();
        });
    });

    $("div.account_page_data").on('input', '#with_text_search', function(e) {
        setFilter('popularity');
        filterItems($(this).attr('data-partial'), { sort_by: 'popularity', with_text_query: $(this).val() });
    });

    $("div.account_page_data").on('click', 'a.load_more', function(e) {
        var currentPage = $(this).attr('data-current-page');
        var nextPage = $(this).attr('data-next-page');
        var href = $(this).attr('data-partial');

        loadPage(href, currentPage, nextPage);
    });

    $("div.account_page_data").on('click', 'a.remove_list_item', function(e) {
        var href = $(this).attr('href');
        var cardToRemove = $(this).attr('data-media-card');

        $.ajax({
            url: href,
            method: 'DELETE',
            beforeSend: function() {
                activatePageLoader(pageLoader);
            }
        }).fail(function() {
            showError('Oops!, Hay un problema.');
            deactivatePageLoader(pageLoader);
        }).done(function(response) {
            deactivatePageLoader(pageLoader);

            $('#' + cardToRemove).fadeOut(500, function(){
                $(this).remove();
            });
        });
    });

});

function loadPage(href, currentPage, nextPage) {
    $.ajax({
        url: href,
        beforeSend: function() {
            activatePageLoader(pageLoader);
            $('p.load_more').addClass('hide');
            $('#pagination_page_' + currentPage + ' div.loading_wrapper').removeClass('hide');
        }
    }).fail(function() {
        showError('Oops!, Hay un problema.');
        deactivatePageLoader(pageLoader);
    }).done(function(response) {
        $('#pagination_page_' + currentPage).addClass('hide');
        $('.items_wrapper').append(response);

        deactivatePageLoader(pageLoader);
        $('#results_page_' + nextPage + ' div.card.v4 div.overview').dotdotdot();

        createInview($('#pagination_page_' + nextPage));
        $("time.timeago").timeago();
    });
}

function createInview(element) {
    new Waypoint.Inview({
        element: element,
        enter: function(direction) {
            var loadMore = $(this.element).find('a.load_more');
            loadMore.click();

            this.disable();
        },
        offset: {
            bottom: -800
        }
    });
}

function setFilter(filter) {
    $('span.sort_text').addClass('hide');
    $('span#sort_by_' + filter).removeClass('hide');

    $('ul.filters li').removeClass('selected');
    $('li#filter_by_' + filter).addClass('selected');
}

function clearWithTextSearch() {
    $('form.item_search_form').addClass('hide');
    $('#with_text_search').val('');
    delete(requestParams.with_text_query);
}

function filterItems(partial_href, params) {
    var data = $.extend(requestParams, { sort_order: $('a.sort_order.selected').attr('data-order') });

    if ( params ) {
        $.extend(data, params);
    }

    $.ajax({
        url: kendo.format("{0}/{1}", partial_href, media_type),
        data: data,
        beforeSend: function() {
            activatePageLoader(pageLoader);
        }
    }).fail(function() {
        showError('Oops!, Hay un problema.');
        deactivatePageLoader(pageLoader);
    }).done(function(response) {
        $('div.items_wrapper').html(response);

        deactivatePageLoader(pageLoader);
        $('div.card.v4 div.overview').dotdotdot();
        $("time.timeago").timeago();
    });
}

$(function() {
    $('div.header .user_score_chart').easyPieChart({
        lineCap: 'round',
        lineWidth: 6,
        scaleColor: false,
        size: 60,
        animate: {
            duration: 1700,
            enabled: true
        }
    });
});
</script>
{% endblock %}
